exports.createFactory = function(fs,factoryName,config){
	if(!fs.existsSync('./js/factory')){
		fs.mkdirSync('./js/factory');
		
	}
	if(!fs.existsSync("./js/factory/"+factoryName+".js")){
		fs.open("./js/factory/"+factoryName+".js","w+",function(err,fd){
			fs.write(fd,genFactory(factoryName,config));
		})
	}else{
		console.log("[ FAIL ] The factory with the name "+factoryName+" exists!\nThe creation is aborted");
		return 1;
	}
	
}

exports.addFactoryToIndex = function(fs,factoryName){
	var index = fs.readFileSync("./index.html",'utf8');
	var newIndex = index.replace("</body>","<script type=\"text/javascript\" src=\"js/factory/"+factoryName+".js\"> </script>\n\t</body>");
	fs.open("./index.html","w+",function(err,fd){
		fs.write(fd,newIndex);
	})
}

exports.addFactoryToAppJS = function(fs,factoryName){
	var appjs = fs.readFileSync("./settings/app.js",'utf8');
	var newAppJS = appjs.replace("//%Anchor",",'"+factoryName+"'\n\t//%Anchor");
	fs.open("./settings/app.js","w+",function(err,fd){
		fs.write(fd,newAppJS);
	})
}

function genFactory(factoryName,config){
	
	var factoryJS = "'use strict';\n";
	factoryJS += "var factory"+factoryName+" = angular.module('"+factoryName+"',[]);\n";
	factoryJS += "factory"+factoryName+".factory('"+factoryName+"',function(){\n\tvar self = {};\n\t\n\treturn self;\n});";
		
		return factoryJS;
	
}
