exports.createService = function(fs,serviceName,config){
	if(!fs.existsSync('./js/service')){
		fs.mkdirSync('./js/service');
		
	}
	if(!fs.existsSync("./js/service/"+serviceName+".js")){
		fs.open("./js/service/"+serviceName+".js","w+",function(err,fd){
			fs.write(fd,genService(serviceName,config));
		})
	}else{
		console.log("[ FAIL ] The service with the name "+serviceName+" exists!\nThe creation is aborted");
		return 1;
	}
	
}

exports.addServiceToIndex = function(fs,serviceName){
	var index = fs.readFileSync("./index.html",'utf8');
	var newIndex = index.replace("</body>","<script type=\"text/javascript\" src=\"js/service/"+serviceName+".js\"> </script>\n\t</body>");
	fs.open("index.html","w+",function(err,fd){
		fs.write(fd,newIndex);
	})
}

exports.addServiceToAppJS = function(fs,serviceName){
	var appjs = fs.readFileSync("./settings/app.js",'utf8');
	var newAppJS = appjs.replace("//%Anchor",",'"+serviceName+"'\n\t//%Anchor");
	fs.open("./settings/app.js","w+",function(err,fd){
		fs.write(fd,newAppJS);
	})
}

function genService(serviceName,config){
	
	var serviceJS = "'use strict';\n";
	serviceJS += "var service"+serviceName+" = angular.module('"+serviceName+"',[]);\n";
	serviceJS += "service"+serviceName+".service('"+serviceName+"',function(){\n\t//remember:Use this.nameOfFunction for a method in this service\n\t\n});";
		
		return serviceJS;
	
}